{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# GUI examples with tk\n",
    "\n",
    "Se show some example codes for GUI using Tk."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## GUI including sliders, buttons\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {
    "collapsed": false
   },
   "outputs": [
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "/home/toyoki/.pyenv/versions/anaconda2-2.5.0/lib/python2.7/site-packages/matplotlib/font_manager.py:273: UserWarning: Matplotlib is building the font cache using fc-list. This may take a moment.\n",
      "  warnings.warn('Matplotlib is building the font cache using fc-list. This may take a moment.')\n"
     ]
    }
   ],
   "source": [
    "# -*- coding: utf-8 -*-\n",
    "\"\"\"\n",
    "Created on April 2017\n",
    "\n",
    "This doesn't work if it's runninig on a remote host via network\n",
    "\n",
    "@author: toyoki\n",
    "\"\"\"\n",
    "\n",
    "#  Derived from\n",
    "#   chaos-3.py\n",
    "#\n",
    "#  Build Feigenbaum Logistic map. Input start and end K\n",
    "#\n",
    "#  python chaos-3.py 3.4 3.9  \n",
    "#\n",
    "from Tkinter import * #Tk, Canvas, Frame, Button, Scale\n",
    "from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg\n",
    "from matplotlib.figure import Figure\n",
    "from matplotlib.lines import Line2D\n",
    "\n",
    "\n",
    "class showMap(Frame):  # inheritate the Tk frame\n",
    "\n",
    "    def __init__(self, master=None):\n",
    "        self.frame = Frame(master)\n",
    "        # plotting plane object\n",
    "        self.fig = Figure()\n",
    "        self.ax = self.fig.add_subplot(111)\n",
    "        self.canvas = FigureCanvasTkAgg(self.fig, master=master)\n",
    "        self.canvas.get_tk_widget().pack()\n",
    "        self.frame.pack(side=\"top\")\n",
    "        self.run(3.5,3.9,0.0,1.0,300)\n",
    "        \n",
    "    def run (self, k1, k2, ymin, ymax, iteration) :\n",
    "        self.ax.set_ylim(ymin, ymax)\n",
    "        self.ax.set_xlim(k1,k2)\n",
    "        \n",
    "        x = .8                     # initial value of the map, which is somewhat arbitrary\n",
    "        transient_range = range(100)\n",
    "        iteration_range = range(iteration)\n",
    "        k_step = (k2 -k1)/200  # unit of horizontal iteration\n",
    "        k = k1\n",
    "        while k <=k2 :\n",
    "            for i in transient_range :\n",
    "                x = x* (1-x) * k               # transient region is not drawn\n",
    "            x_n = []\n",
    "            y_n = []\n",
    "            for i in iteration_range:\n",
    "                x = x * (1-x) * k              # next x value\n",
    "                y_n.append(x)\n",
    "                x_n.append(k)\n",
    "                if x <0 or x >= 1.0 :\n",
    "                    print(\"overflow at k\", k)\n",
    "            self.ax.plot(x_n, y_n, \"b.\", markersize='1')\n",
    "            k = k + k_step\n",
    "        self.canvas.show() # to make a new plot visible\n",
    "        return\n",
    "\n",
    "class controlFrame() :\n",
    "    \"\"\"\n",
    "    Control frame for setting parameters and control buttons\n",
    "    \"\"\"\n",
    "    def setupControlBox (self) :\n",
    "    \n",
    "        # control buttons\n",
    "        self.controlBox.StartBtn = Button(self.controlBox,text=u\"start\", width=100)\n",
    "        self.controlBox.StartBtn.bind(\"<Button-1>\", self.startApp)\n",
    "\n",
    "        # sliders for parameter setting\n",
    "        self.controlBox.set_k1 = Scale(self.controlBox, from_=1.8, to=3.9, resolution=0.01, orient=HORIZONTAL, label=\"min\", length=500)\n",
    "        self.controlBox.set_k2 = Scale(self.controlBox, from_=1.8, to=3.9, resolution=0.01, orient=HORIZONTAL, label=\"max\", length=500)\n",
    "        self.controlBox.set_k1.set(self.k1) # initial value\n",
    "        self.controlBox.set_k2.set(self.k2)\n",
    "        # vertical width\n",
    "        self.controlBox.set_y1 = Scale(self.controlBox, from_=0.0, to=1.0, resolution=0.02, orient=HORIZONTAL, label=\"y_min\", length=500)\n",
    "        self.controlBox.set_y2 = Scale(self.controlBox, from_=0.0, to=1.0, resolution=0.02, orient=HORIZONTAL, label=\"y_max\", length=500)\n",
    "        self.controlBox.set_y1.set(self.y1) # initial value\n",
    "        self.controlBox.set_y2.set(self.y2)\n",
    "        # number of iterations\n",
    "        self.controlBox.set_iter = Scale(self.controlBox, from_=300, to=5000, resolution=100, orient=HORIZONTAL, label=\"iteration\", length=500)\n",
    "        \n",
    "        # pack widgets in the control frame\n",
    "        self.controlBox.StartBtn.pack()\n",
    "        self.controlBox.set_k1.pack()\n",
    "        self.controlBox.set_k2.pack()\n",
    "        self.controlBox.set_y1.pack()\n",
    "        self.controlBox.set_y2.pack()\n",
    "        self.controlBox.set_iter.pack()\n",
    "        return\n",
    "    \n",
    "    def startApp (self, ev) :\n",
    "        k1 = self.controlBox.set_k1.get()\n",
    "        k2 = self.controlBox.set_k2.get()\n",
    "        y1 = self.controlBox.set_y1.get()\n",
    "        y2 = self.controlBox.set_y2.get()\n",
    "        iteration = self.controlBox.set_iter.get()\n",
    "        self.mapObj.run(k1,k2,y1,y2,iteration)\n",
    "            \n",
    "    # constructor of control panel\n",
    "    def __init__(self, master=None, mapFrame=None, k1=3.5, k2=3.9, y1=0.0, y2=1.0, iteration=300):\n",
    "        self.k1 =k1\n",
    "        self.k2 =k2\n",
    "        self.y1 =y1\n",
    "        self.y2 =y2\n",
    "        self.iteration =iteration\n",
    "        self.controlBox = Frame(master)\n",
    "        self.setupControlBox()\n",
    "        self.controlBox.pack(side=\"bottom\")\n",
    "        self.mapObj=mapFrame\n",
    "        \n",
    "# end of controlBox class\n",
    "\n",
    "if __name__ == \"__main__\" :\n",
    "    root = Tk() # parent for all\n",
    "    mapF = showMap(master=root)\n",
    "    app = controlFrame(master=root, mapFrame=mapF)\n",
    "    root.mainloop()      # Just wait for user to close graph\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Giving parameters by textboxes\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": [
    "# -*- coding: utf-8 -*-\n",
    "\"\"\"\n",
    "Created on April 2017\n",
    "\n",
    "@author: toyoki\n",
    "\"\"\"\n",
    "\n",
    "#  Derived from\n",
    "#   chaos-3.py\n",
    "#\n",
    "#  Build Feigenbaum Logistic map. Input start and end K\n",
    "#\n",
    "#  python chaos-3.py 3.4 3.9  \n",
    "#\n",
    "from Tkinter import * #Tk, Canvas, Frame, Button, Scale\n",
    "from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg\n",
    "from matplotlib.figure import Figure\n",
    "from matplotlib.lines import Line2D\n",
    "\n",
    "\n",
    "class showMap(Frame):  # inheritate the Tk frame\n",
    "\n",
    "    def __init__(self, master=None):\n",
    "        self.frame = Frame(master)\n",
    "        # plotting plane object\n",
    "        self.fig = Figure()\n",
    "        self.ax = self.fig.add_subplot(111)\n",
    "        self.canvas = FigureCanvasTkAgg(self.fig, master=master)\n",
    "        self.canvas.get_tk_widget().pack()\n",
    "        self.frame.pack(side=\"top\")\n",
    "        self.run(3.5,3.9,0.0,1.0,300)\n",
    "        \n",
    "    def run (self, k1, k2, ymin, ymax, iteration) :\n",
    "        self.ax.set_ylim(ymin, ymax)\n",
    "        self.ax.set_xlim(k1,k2)\n",
    "        self.ax.clear()\n",
    "        x = .8                     # initial value of the map, which is somewhat arbitrary\n",
    "        transient_range = range(100)\n",
    "        iteration_range = range(iteration)\n",
    "        k_step = (k2 -k1)/200  # unit of horizontal iteration\n",
    "        k = k1\n",
    "        while k <=k2 :\n",
    "            for i in transient_range :\n",
    "                x = x* (1-x) * k               # transient region is not drawn\n",
    "            x_n = []\n",
    "            y_n = []\n",
    "            for i in iteration_range:\n",
    "                x = x * (1-x) * k              # next x value\n",
    "                y_n.append(x)\n",
    "                x_n.append(k)\n",
    "                if x <0 or x >= 1.0 :\n",
    "                    print \"overflow at k\", k\n",
    "            self.ax.plot(x_n, y_n, \"b.\", markersize='1')\n",
    "            k = k + k_step\n",
    "        self.canvas.show() # to make a new plot visible\n",
    "        return\n",
    "\n",
    "class controlFrame() :\n",
    "    \"\"\"\n",
    "    Control frame for setting parameters and control buttons\n",
    "    \"\"\"\n",
    "    def setupControlBox (self) :\n",
    "    \n",
    "        # control buttons\n",
    "        self.controlBox.StartBtn = Button(self.controlBox,text=u\"start\")\n",
    "        self.controlBox.StartBtn.bind(\"<Button-1>\", self.startApp)\n",
    "        self.controlBox.ResetBtn = Button(self.controlBox,text=u\"reset\")\n",
    "        self.controlBox.ResetBtn.bind(\"<Button-1>\", self.resetApp)\n",
    "\n",
    "        # sliders for parameter setting\n",
    "        self.controlBox.Lx1 = Label(self.controlBox, text=\"x_min\")\n",
    "        self.controlBox.Lx2 = Label(self.controlBox, text=\"x_max\")\n",
    "        self.controlBox.set_k1 = Entry(self.controlBox)\n",
    "        self.controlBox.set_k2 = Entry(self.controlBox, text=\"x_max\")\n",
    "        self.controlBox.set_k1.insert(END, self.k1) # initial value\n",
    "        self.controlBox.set_k2.insert(END,self.k2)\n",
    "        # vertical width\n",
    "        self.controlBox.Ly1 = Label(self.controlBox, text=\"y_min\")\n",
    "        self.controlBox.Ly2 = Label(self.controlBox, text=\"y_max\")\n",
    "        self.controlBox.set_y1 = Entry(self.controlBox, text=\"y_min\")\n",
    "        self.controlBox.set_y2 = Entry(self.controlBox, text=\"y_max\")\n",
    "        self.controlBox.set_y1.insert(END,self.y1) # initial value\n",
    "        self.controlBox.set_y2.insert(END,self.y2)\n",
    "        # number of iterations\n",
    "        self.controlBox.Liter = Label(self.controlBox, text=\"# of iterations\")\n",
    "        self.controlBox.set_iter = Entry(self.controlBox)\n",
    "        self.controlBox.set_iter.insert(END, self.iteration)\n",
    "        \n",
    "        # pack widgets in the control frame\n",
    "        self.controlBox.Lx1.grid(row=0, column=0)\n",
    "        self.controlBox.set_k1.grid(row=0, column=1)\n",
    "        self.controlBox.Lx2.grid(row=0, column=2)\n",
    "        self.controlBox.set_k2.grid(row=0, column=3)\n",
    "        self.controlBox.Ly1.grid(row=1, column=0)\n",
    "        self.controlBox.set_y1.grid(row=1, column=1)\n",
    "        self.controlBox.Ly2.grid(row=1, column=2)\n",
    "        self.controlBox.set_y2.grid(row=1, column=3)\n",
    "        self.controlBox.Liter.grid(row=2, column=0)\n",
    "        self.controlBox.set_iter.grid(row=2, column=1)\n",
    "        self.controlBox.StartBtn.grid(row=2, column=2)\n",
    "        self.controlBox.ResetBtn.grid(row=2, column=3)\n",
    "\n",
    "        return\n",
    "    \n",
    "    def startApp (self, ev) :\n",
    "        k1 = float(self.controlBox.set_k1.get())\n",
    "        k2 = float(self.controlBox.set_k2.get())\n",
    "        y1 = float(self.controlBox.set_y1.get())\n",
    "        y2 = float(self.controlBox.set_y2.get())\n",
    "        iteration = int(self.controlBox.set_iter.get())\n",
    "        print k1, k2,y1,y2, iteration\n",
    "        self.mapObj.run(k1,k2,y1,y2,iteration)\n",
    "\n",
    "    def resetApp(self, ev):\n",
    "        \n",
    "        self.mapObj.run(self.k1, self.k2, self.y1, self.y2, self.iteration)\n",
    "        \n",
    "    # constructor of control panel\n",
    "    def __init__(self, master=None, mapFrame=None, k1=3.5, k2=3.9, y1=0.0, y2=1.0, iteration=300):\n",
    "        self.k1 =k1\n",
    "        self.k2 =k2\n",
    "        self.y1 =y1\n",
    "        self.y2 =y2\n",
    "        self.iteration =iteration\n",
    "        self.controlBox = Frame(master)\n",
    "        self.setupControlBox()\n",
    "        self.controlBox.pack(side=\"bottom\")\n",
    "        self.mapObj=mapFrame\n",
    "        \n",
    "# end of controlBox class\n",
    "\n",
    "if __name__ == \"__main__\" :\n",
    "    root = Tk() # parent for all\n",
    "    mapF = showMap(master=root)\n",
    "    app = controlFrame(master=root, mapFrame=mapF)\n",
    "    root.mainloop()      # Just wait for user to close graph\n",
    "\n"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 2",
   "language": "python",
   "name": "python2"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 2
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython2",
   "version": "2.7.11"
  },
  "latex_envs": {
   "bibliofile": "biblio.bib",
   "cite_by": "apalike",
   "current_citInitial": 1,
   "eqLabelWithNumbers": true,
   "eqNumInitial": 0
  },
  "toc": {
   "toc_cell": false,
   "toc_number_sections": true,
   "toc_threshold": 6,
   "toc_window_display": false
  }
 },
 "nbformat": 4,
 "nbformat_minor": 1
}
